//
// This program and source are subject to the GPL Open Source License
// Please refer to the following document
// http://www.borland.com/kylix/gpl.html

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <mmsystem.h>
#include "Win_RT_Form.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TWinRealtimeForm *WinRealtimeForm;
//---------------------------------------------------------------------------
__fastcall TWinRealtimeForm::TWinRealtimeForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TWinRealtimeForm::FormShow(TObject *Sender)
{
//
}
//---------------------------------------------------------------------------
void __fastcall TWinRealtimeForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  StopButtonClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TWinRealtimeForm::StartButtonClick(TObject *Sender)
{
  StartButton->Enabled=false;
  StopButton->Enabled=true;
  ClockRate->Enabled=false;
  UDP_Host->Enabled=false;
  PLevel->Enabled=false;
  TLevel->Enabled=false;

  switch (PLevel->ItemIndex)
  {
    case 0: SetPriorityClass(GetCurrentProcess(),IDLE_PRIORITY_CLASS); break;
    case 1: SetPriorityClass(GetCurrentProcess(),NORMAL_PRIORITY_CLASS); break;
    case 2: SetPriorityClass(GetCurrentProcess(),HIGH_PRIORITY_CLASS); break;
    case 3: SetPriorityClass(GetCurrentProcess(),REALTIME_PRIORITY_CLASS); break;
  }

  SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);

  IdUDPClient1->Host=UDP_Host->Text;
  IdUDPClient1->Active=RunUDP->Checked;
  if (RunUDP->Checked) IdUDPClient1->Active=true;
  ClockRateSet=ClockRate->ItemIndex+1;
  timeBeginPeriod(ClockRateSet);
  RT_Thread=new TRtTestThread();

  switch (TLevel->ItemIndex)
  {
    case 0: RT_Thread->Priority=tpIdle; break;
    case 1: RT_Thread->Priority=tpLowest; break;
    case 2: RT_Thread->Priority=tpLower; break;
    case 3: RT_Thread->Priority=tpNormal; break;
    case 4: RT_Thread->Priority=tpHigher; break;
    case 5: RT_Thread->Priority=tpHighest; break;
    case 6: RT_Thread->Priority=tpTimeCritical; break;
  }

  RT_Thread->MF=this;
  RT_Thread->Resume();
  Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TWinRealtimeForm::StopButtonClick(TObject *Sender)
{
  Timer1->Enabled=false;
  if (RT_Thread!=NULL)
  {
    RT_Thread->Terminate();
    RT_Thread->WaitFor();
    delete RT_Thread;
    RT_Thread=NULL;
  }
  timeEndPeriod(ClockRateSet);
  StartButton->Enabled=true;
  StopButton->Enabled=false;
  ClockRate->Enabled=true;
  UDP_Host->Enabled=true;
  PLevel->Enabled=true;
  TLevel->Enabled=true;
  IdUDPClient1->Active=false;
}
//---------------------------------------------------------------------------
void __fastcall TWinRealtimeForm::Timer1Timer(TObject *Sender)
{
  static bool InTimer=false;

  if (!InTimer)
  {
    InTimer=true;
    try
    {
      if (RT_Thread!=NULL)
      {
        ActualRate->Text=FormatFloat("0.000000",RT_Thread->RunPeriod);

        AnsiString S;
        int Total=0;

        Memo1->Clear();
        S.printf("%10s %10s %8s","Seconds","Count","%");
        Memo1->Lines->Add(S);
        
        for (int i=0;i<HMAX;i++) Total+=RT_Thread->HSec[i];
        if (Total<=0) Total=1;


        for (int i=0;i<HMAX;i++)
        {
          double t=i*0.001;
          int c=RT_Thread->HSec[i];
          if (i==HMAX-1) t=RT_Thread->MaxTime;

          if (c>0)
          {
            S.printf("%10.3f %10d %8.3f",t,c,c*100.0/Total);
            if (i==HMAX-1) S=S+" max";
            Memo1->Lines->Add(S);
          }
        }
      }
    }
    __finally
    {
      InTimer=false;
    }
  }
}
//---------------------------------------------------------------------------
__fastcall TRtTestThread::TRtTestThread(void):TThread(true)
{
	FreeOnTerminate=false;
}
//---------------------------------------------------------------------------
void __fastcall TRtTestThread::Execute(void)
{
  HANDLE hTE=(HANDLE)CreateWaitableTimer(NULL,false,NULL);
  if (hTE!=NULL)
  {
  	LARGE_INTEGER tLT;
    tLT.QuadPart=0;
    if (!SetWaitableTimer(hTE,&tLT,MF->ClockRateSet,NULL,NULL,true))
    {
      CloseHandle(hTE);
      hTE=NULL;
    }
  }

  HRT=new THighResTimer();
  double tt=0.0;
  unsigned char Buf[64];
  MaxTime=0.0;

  for (int i=0;i<10;i++)
  {
    if (hTE==NULL) Sleep(MF->ClockRateSet);
    else WaitForSingleObject(hTE,MF->ClockRateSet*10);
  }

	while (!Terminated)
  {
    double t1=HRT->HighResTime();

    if (hTE==NULL) Sleep(MF->ClockRateSet);
    else WaitForSingleObject(hTE,MF->ClockRateSet*10);

    double t2=HRT->HighResTime();
    double dt=t2-t1;
    tt+=dt;

    int h=dt*1000.0+0.5;
    if (h<0) h=0;
    if (h>=HMAX)
    {
      h=HMAX-1;
      if (dt>MaxTime) MaxTime=dt;
    }
    HSec[h]++;

    RunCount++;
    if (RunCount>=100)
    {
      RunPeriod=tt/RunCount;
      tt=0.0;
      RunCount=0;
    }

    if (MF->RunUDP->Checked)
    {
      try
      {
        if (!MF->IdUDPClient1->Active)
        {
          MF->IdUDPClient1->Active=true;
        }
        else
        {
          MF->IdUDPClient1->SendBuffer(Buf,sizeof(Buf));
        }
      }
      catch (...)
      {
      }
    }
  }

  if (hTE!=NULL) CloseHandle(hTE);
  delete HRT;
}
//---------------------------------------------------------------------------
__fastcall THighResTimer::THighResTimer(void)
	: TObject()
{
  QueryPerformanceFrequency(&f);
  na=f.QuadPart==0;
  HighResReset();
}
//---------------------------------------------------------------------------
void __fastcall THighResTimer::HighResReset(void)
{
  QueryPerformanceCounter(&t0);
  last_dt=0.0;
  et=0.0;
}
//---------------------------------------------------------------------------
double __fastcall THighResTimer::HighResTime(void)
{
	double dt;

  if (na) return 0.0;

  QueryPerformanceCounter(&t1);
  dt=t1.QuadPart-t0.QuadPart;
  if (dt<0.0)
  {
		et=et+last_dt/f.QuadPart;
    t0=t1;
		last_dt=0.0;
    return et;
  }
	else
  {
  	last_dt=dt;
 		return et+dt/f.QuadPart;
  }
}
//---------------------------------------------------------------------------
